package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.PricingClasseTarifariaDAO;
import com.rjconsultores.ventaboletos.entidad.PricingClasseTarifaria;
import com.rjconsultores.ventaboletos.service.PricingClasseTarifariaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

@Service("pricingClasseTarifariaService")
public class PricingClasseTarifariaServiceImpl implements PricingClasseTarifariaService {

	@Autowired
	private PricingClasseTarifariaDAO pricingClasseTarifariaDAO;

	@Override
	public List<PricingClasseTarifaria> obtenerTodos() {
		return pricingClasseTarifariaDAO.obtenerTodos();
	}

	@Override
	public PricingClasseTarifaria obtenerID(Integer id) {
		return pricingClasseTarifariaDAO.obtenerID(id);
	}

	@Override
	@Transactional
	public PricingClasseTarifaria suscribir(PricingClasseTarifaria entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);
		return pricingClasseTarifariaDAO.suscribir(entidad);
	}

	@Override
	@Transactional
	public PricingClasseTarifaria actualizacion(PricingClasseTarifaria entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);
		return pricingClasseTarifariaDAO.actualizacion(entidad);
	}

	@Override
	@Transactional
	public void borrar(PricingClasseTarifaria entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.FALSE);
		pricingClasseTarifariaDAO.actualizacion(entidad);
	}

	public Boolean validacionSigla(String sigla) {
		return pricingClasseTarifariaDAO.validacionSigla(sigla);
	}

}
